<?php

// Define a function to verify the payment
function verifyPayment($invoiceId) {
    $baseURL = 'https://payment.signifx.club/api/verify-payment'; // Base URL for the verify payment API
    $apiKEY = '0723aa1bd8091250080e49c8e683c8793e6d123f'; // API key

    // Initialize cURL
    $curl = curl_init();

    // Set cURL options
    curl_setopt_array($curl, [
        CURLOPT_URL => $baseURL,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => json_encode(['invoice_id' => $invoiceId]),
        CURLOPT_HTTPHEADER => [
            "RT-UDDOKTAPAY-API-KEY: " . $apiKEY,
            "Accept: application/json",
            "Content-Type: application/json"
        ],
    ]);

    // Execute cURL request and get the response
    $response = curl_exec($curl);
    $err = curl_error($curl);

    // Close cURL resource
    curl_close($curl);

    if ($err) {
        return json_encode(["status" => "ERROR", "message" => "cURL Error #: " . $err]);
    } else {
        // Return the response
        return $response;
    }
}

// Handle incoming POST request
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Get the request data
    $requestData = json_decode(file_get_contents('php://input'), true);

    // Validate the request data
    if (isset($requestData['invoice_id'])) {
        // Call the function to verify the payment
        echo verifyPayment($requestData['invoice_id']);
    } else {
        // Return error if required data is missing
        echo json_encode(['status' => 'ERROR', 'message' => 'Missing invoice_id']);
    }
} else {
    // Return error if the request method is not POST
    echo json_encode(['status' => 'ERROR', 'message' => 'Invalid request method']);
}
?>
